@extends('layouts.app', ['title' => __('User Management')])

@section('content')
    @include('layouts.headers.cards')

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <div class="row align-sales-center">
                            <div class="col-2">
                                <h3 class="mb-0">{{ __('Liste des Commandes') }}</h3>
                            </div>
                            <div class="col-6">
                                @if($Success=Session::get('info'))
                                    <div class="alert alert-success">{{$Success}}</div>
                                @endif
                            </div>
                            <div class="col-4 text-right">
                                <a href="{{ route('sale') }}" class="btn btn-sm btn-primary">{{ __('Enregistrer une vente') }}</a>
                            </div>
                        </div>
                    </div>

                    <div class="col-12">
                        @if (session('status'))
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                                {{ session('status') }}
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                        @endif
                    </div>

                    <div class="table-responsive" style="padding:10px">
                        <table id="example1" class="table table-bordered table-striped">
                            <thead class="thead-light">
                            <tr>
                                {{--                                <th scope="col">{{ __('Image') }}</th>--}}
                                <th>#</th>
                                <th scope="col">{{ __('Date d\'enregistrement') }}</th>
                                <th scope="col">{{ __('Nom du produits') }}</th>
                                <th scope="col">{{ __('Quantités') }}</th>
                                {{--<th scope="col"></th>--}}
                            </tr>
                            </thead>
                            <tbody>
                            @foreach ($Commande as $i=>$c)
                                <tr>
                                    <td>{{$i+1}}</td>
                                    <td>{{$c->created_at}}</td>
                                    <td>
                                         @php
                                            $Item=\App\Models\Item::find($c->item_id);
                                         @endphp
                                        @if($Item)
                                            {{$Item->name}}
                                        @else
                                            Produit inconnu
                                        @endif
                                    </td>
                                    <td>{{$c->quantity}}</td>
                                </tr>
                            @endforeach
                            </tbody>
                        </table>
                    </div>

                </div>
            </div>
        </div>
        @include('layouts.footers.auth')
    </div>

    @push('js')
    <script>
        $('.paid').each(function(){
            if($(this).prop('checked')){
                $(this).attr('disabled', 'disabled')
            }
        })
        $('.paid').change(function(){
            $.post('{{ route('togglePaid') }}', { _token : "{{ csrf_token() }}", id : $(this).attr('data-id') }, function(rsp){
                console.log(rsp)
            })
            if($(this).prop('checked')){
                $(this).attr('disabled', 'disabled')
            }
        })
    </script>
    @endpush
@endsection