@extends('layouts.app', ['title' => __('User Management')])

@section('content')
    @include('layouts.headers.cards')

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">{{ __('Produits') }}</h3>
                            </div>
                            <div class="col-4 text-right">
{{--                                <a href="{{ route('createItem') }}" class="btn btn-sm btn-primary">{{ __('Ajouter un produit') }}</a>--}}
                            </div>
                        </div>
                    </div>
                    <div class="col-12">
                        @if (session('status'))
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                                {{ session('status') }}
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                        @endif
                    </div>
                    <div style="padding: 10px" class="input-daterange datepicker align-items-center">
                        <form action="{{ route('search') }}">
                            @csrf
                            <div class="row">
                                <div class="col-md-8">
                                    &nbsp; Du
                                    <input type="date" class="form-control" required name="start" required placeholder="Date début" value="{{  date('Y-m-d', strtotime('-'. $today_year  .' days')) }}" style="width: 200px; display: inline-block">
                                    &nbsp; Au
                                    <input type="date" class="form-control" required name="end" required placeholder="Date fin" value="{{  $today_year }}" style="width: 200px; display: inline-block">
                                </div>
                                <div class="col-md-4">
                                    <button type="submit" class="btn btn-success">Afficher les entrées et sorties</button>
                                </div>
                            </div>
                        </form>
                    </div>
                    <p>
                        <a style="margin-left: 20px" class="btn btn-primary btn-sm" data-toggle="collapse" href="#entree" role="button" aria-expanded="false" aria-controls="collapseExample">
                            Liste des Entrées
                        </a>
                        <button class="btn btn-success btn-sm" type="button" data-toggle="collapse" data-target="#sortie" aria-expanded="false" aria-controls="collapseExample">
                            Liste des Sorties
                        </button>
                    </p>
                    <div class="collapse" id="entree">
                        <div class="card card-body">
                            <div class="table-responsive" style="padding:10px">
                                <table id="example1" class="table table-bordered table-striped">
                                    <thead>
                                    <th colspan="5">Liste des ravitaillements</th>
                                    </thead>
                                    <thead class="thead-light">
                                    <tr>
                                        <th scope="col">{{ __('Date d\'enregistrement') }}</th>
                                        <th scope="col">{{ __('Fournisseur') }}</th>
                                        <th scope="col">{{ __('Produits') }}</th>
                                        <th scope="col">{{ __('Quantités') }}</th>
                                        <th scope="col">{{ __('Chargé') }}</th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    @forelse ($ravi as $r)
                                        <tr>
                                            <td>{{ $r->created_at->format('d-m-Y H:i:s') }}</td>
                                            <td>
                                                @php
                                                   $Supplie=\App\Models\Supplier::where('id','=',$r->idSupplie)->first();
                                                @endphp
                                                @if($Supplie)
                                                    {{$Supplie->name}}
                                                @else
                                                  Fournisseur inconnu
                                                @endif
                                            </td>
                                            <td>
                                                @php
                                                    $Item=\App\Models\Item::find($r->idItem);
                                                @endphp
                                                @if($Item)
                                                    {{ $Item->name }}
                                                @else
                                                    Produit inconnu
                                                @endif
                                            </td>
                                            <td>
                                                {{$r->quantity}}
                                            </td>
                                            <td>

                                                @php
                                                  $Charge=\App\User::where('id','=',$r->idAdmin)->first();
                                                @endphp
                                                @if($Charge)
                                                    {{$Charge->name}}
                                                @else
                                                   Chargé Inconnu
                                                @endif
                                            </td>
                                        </tr>
                                    @empty
                                        <tr>
                                            <td colspan="10">
                                                <div style="text-align: center; font-size: 14px">Aucune recherche ne correspond à votre demande</div>
                                            </td>
                                        </tr>
                                    @endforelse
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                    <div class="collapse" id="sortie">
                        <div class="card card-body">
                            <div class="table-responsive" style="padding:10px">
                                <table id="example1" class="table table-bordered table-striped">
                                    <thead>
                                    <th colspan="5">Liste des ventes</th>
                                    </thead>
                                    <thead class="thead-light">
                                    <tr>
                                        <th scope="col">{{ __('Date d\'enregistrement') }}</th>
                                        <th scope="col">{{ __('Client') }}</th>
                                        <th scope="col">{{ __('Total') }}</th>
                                        <th scope="col">{{ __('Détails') }}</th>
                                        <th scope="col">{{ __('Imprimer') }}</th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    @forelse ($sales as $sale)
                                        <tr>
                                            <td>{{ $sale->created_at->format('d-m-Y H:i:s') }}</td>
                                            <td>
                                                @php
                                                    $Customer=\App\Models\Customer::find($sale->customer_id);
                                                @endphp
                                                @if($Customer)
                                                    {{ $Customer->name }}
                                                @else
                                                    {{$sale->customer_id}}
                                                @endif
                                            </td>
                                            <td>{{ $sale->total }}</td>
                                            <td><a href="{{ route('sale',$sale->id) }}"><i class="fas fa-info-circle"></i></a></td>
                                            <td><a href="{{ route('print',$sale->id) }}" target="_blank"><i class="fas fa-print"></i></a></td>
                                        </tr>
                                    @empty
                                        <tr>
                                            <td colspan="10">
                                                <div style="text-align: center; font-size: 14px">Aucune recherche ne correspond à votre demande</div>
                                            </td>
                                        </tr>
                                    @endforelse
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                    <div class="card-footer py-4">
                        <nav class="d-flex justify-content-end" aria-label="...">
                            {{--                            {{ $users->links() }}--}}
                        </nav>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection

@push('js')
    <script>
        @php
            $date = new DateTime();
            $date->sub(new DateInterval('P1D'));
        @endphp
        $('[name="start"]').val('{{ date('Y-m-d', strtotime('-'. $today_year  .' days'))}}')
        $('[name="end"]').val('{{ $today_year }}')
    </script>
@endpush