<?php $__env->startSection('content'); ?>
    <?php echo $__env->make('layouts.headers.cards', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <?php if($errors->any()): ?>
                            <div class="msg" style="background: lightgreen; width: 100%; border-radius: 4px; padding: 0px 15px; margin: auto; ">
                                <p style="color: darkgreen; vertical-align: middle">
                                    <?php echo e($errors->first()); ?>

                                </p>
                            </div><br>
                        <?php endif; ?>
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0"><?php echo e(__('Catégories')); ?></h3>
                            </div>
                            <?php if(auth()->user()->isAdmin()): ?>
                            <div class="col-4 text-right">
                                <a href="<?php echo e(route('createCategory')); ?>" class="btn btn-sm btn-primary"><?php echo e(__('Ajouter une catégorie')); ?></a>
                            </div>
                            <?php endif; ?>
                        </div>
                    </div>

                    <div class="col-12">
                        <?php if(session('status')): ?>
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                                <?php echo e(session('status')); ?>

                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                        <?php endif; ?>
                    </div>

                    <div class="table-responsive">
                        <table class="table align-items-center table-flush">
                            <thead class="thead-light">
                            <tr>
                                <th scope="col"><?php echo e(__('Nom')); ?></th>
                                <th scope="col"><?php echo e(__('Catégorie parent')); ?></th>
                                <th scope="col"></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php $__currentLoopData = $categories; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $category): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                <tr>
                                    <td><b><?php echo e($category->name); ?></b></td>
                                    <td><?php echo e($category->parent() ? $category->parent()->name : '-'); ?></td>
                                    <td>
                                        <?php if(auth()->user()->isAdmin()): ?>
                                        <a href="/editcategory/<?php echo e($category->id); ?>"><i class="fas fa-pencil-alt"></i></a>
                                        &nbsp;
                                        <?php if(!$category->parent()): ?>
                                            <a href="/deletecategory/<?php echo e($category->id); ?>"><i class="fas fa-trash"></i></a>
                                        <?php endif; ?>
                                        <?php endif; ?>
                                    </td>
                                </tr>
                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                            </tbody>
                        </table>
                    </div>
                    <div class="card-footer py-4">
                        <nav class="d-flex justify-content-end" aria-label="...">

                        </nav>
                    </div>
                </div>
            </div>
        </div>

        <?php echo $__env->make('layouts.footers.auth', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
    </div>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.app', ['title' => __('User Management')], \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php /* /home/easyhtjs/public_html/stock/resources/views/category/list.blade.php */ ?>