<?php $__env->startSection('content'); ?>
    <?php echo $__env->make('users.partials.header', ['title' => __('Vente')], \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

    <div class="container mt--7">
        <div class="row">
            <div class="col-xl-12 order-xl-1">
                <div class="card bg-secondary shadow">
                    <div class="card-header bg-white border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0"><?php echo e(__('Enregistrer une vente')); ?></h3>
                            </div>
                            <div class="col-4 text-right">
                                <a href="<?php echo e(route('sale')); ?>" class="btn btn-sm btn-primary"><?php echo e(__('Retourner à la liste')); ?></a>
                            </div>
                        </div>
                    </div>
                  <div class="container">
                      <?php if($Success=Session::get('success')): ?>
                          <div class="alert alert-success"><?php echo e($Success); ?></div>
                      <?php endif; ?>
                      <div class="row">
                          <div class="col-md-5">
                              <div class="card-body">
                                  <form method="post" action="<?php echo e(route('AddSale')); ?>" autocomplete="off">
                                      <?php echo csrf_field(); ?>
                                      <h6 class="heading-small text-muted mb-4"><?php echo e(__('Informations sur la vente')); ?></h6>
                                      <div class="pl-lg-4">
                                          <?php if($errors->any()): ?>
                                              <div class="msg">
                                                  <p>
                                                      <i class="fas fa-check"></i> <?php echo e($errors->first()); ?>

                                                  </p>
                                              </div>
                                          <?php endif; ?>
                                          <div class="form-group<?php echo e($errors->has('name') ? ' has-danger' : ''); ?>">
                                              <label class="form-control-label" for="input-name"><?php echo e(__('Client')); ?></label><br>
                                              <input name="customer_id" type="hidden" class="form-control" value="<?php echo e($customers->id); ?>">
                                              <input type="text" class="form-control" value="<?php echo e($customers->name); ?>" readonly>
                                          </div>
                                          <div class="row">
                                              <div class="col-md-8">
                                                  <label class="form-control-label" for="input-name"><?php echo e(__('Produit')); ?></label><br>
                                                  <select name="item_id" class="form-control form-control-alternative<?php echo e($errors->has('name') ? ' is-invalid' : ''); ?>"  id="">
                                                      <?php $__currentLoopData = $items; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $item): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                          <option value="<?php echo e($item->id); ?>"><?php echo e($item->name); ?> -
                                                              <?php
                                                                  $Categori=\App\Models\Category::find($item->category_id);
                                                              ?>
                                                              <?php if($Categori): ?>
                                                                  <?php echo e($Categori->name); ?>

                                                              <?php else: ?>
                                                                  Catégorie inconnu
                                                              <?php endif; ?>

                                                          </option>
                                                      <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                                  </select>
                                              </div>
                                              <div class="col-md-4">
                                                  <label class="form-control-label" for="input-name"><?php echo e(__('Quantité')); ?></label>
                                                  <input min="1" type="number" class="form-control form-control-alternative" name="quantity" required>
                                              </div>
                                          </div>

                                          <!-- <button class="btn btn-primary" id="btn-command" type="button">Ajouter un produit <i class="ni ni-fat-add" style="font-size: 1em"></i></button>-->
                                          <br>
                                          <div class="text-center">
                                              <button type="submit" class="btn btn-success mt-4"><?php echo e(__('Enregistrer')); ?></button>
                                          </div>
                                      </div>
                                  </form>
                              </div>
                          </div>
                          <div class="col-md-7">
                              <button type="button" class="btn btn-primary btn-sm" data-toggle="modal" data-target="#exampleModal">
                                 Finaliser la commande
                              </button>
                              <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                                  <div class="modal-dialog" role="document">
                                      <div class="modal-content">
                                          <div class="modal-body">
                                              <form method="post" action="<?php echo e(route('printt')); ?>">
                                                  <?php echo csrf_field(); ?>
                                                  <label>Voulez-vous finalisez la commande ? </label>
                                                  <input type="hidden" value="<?php echo e($total); ?>" name="total">
                                                  <input type="hidden" value="<?php echo e($customers->id); ?>" name="customer_id"><br>
                                                  <input type="submit" class="btn btn-primary btn-sm" style="color:white;margin-left: 80px" value="OUI">
                                                  <button type="button" class="btn btn-secondary btn-sm" data-dismiss="modal">NON</button>
                                              </form>
                                          </div>
                                      </div>
                                  </div>
                              </div>
                              <table class="table table-bordered">
                                  <thead>
                                  <th colspan="4">Liste des produits de <i style="color:green"><?php echo e($customers->name); ?></i>  |  Total: <?php echo e(number_format($total,0,',', '.')); ?> FCFA</th>
                                  </thead>
                                  <thead>
                                  <th>#</th>
                                  <th>Nom du produit</th>
                                  <th>Quantité</th>
                                  <th>Opérations</th>
                                  </thead>
                                  <tbody>
                                     <?php $__currentLoopData = $Commande; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $i=>$c): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                     <tr>
                                        <td><?php echo e($i+1); ?></td>
                                         <td>
                                             <?php
                                                $Item=\App\Models\Item::find($c->item_id);
                                             ?>
                                             <?php if($Item): ?>
                                                 <?php echo e($Item->name); ?>

                                             <?php else: ?>
                                               Produit inconnu
                                             <?php endif; ?>
                                         </td>
                                         <td><?php echo e($c->quantity); ?></td>
                                         <td>
                                             <a href="<?php echo e(route('AnnulerCommande',Crypt::encrypt($c->id))); ?>" class="btn btn-danger btn-sm" style="color:white">Annuler</a>
                                         </td>
                                     </tr>
                                     <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                  </tbody>
                              </table>
                          </div>
                      </div>
                  </div>
                </div>
            </div>
        </div>

        <template id="command">
            <div class="form-group<?php echo e($errors->has('name') ? ' has-danger' : ''); ?>">
                <div style="display: inline-block;">
                    <label class="form-control-label" for="input-name"><?php echo e(__('Produit')); ?></label><br>
                    <select name="item_id[]" class="form-control form-control-alternative<?php echo e($errors->has('name') ? ' is-invalid' : ''); ?>"  id="">
                        <?php $__currentLoopData = $items; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $item): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                            <option value="<?php echo e($item->id); ?>"><?php echo e($item->name); ?> -
                                <?php
                                    $Categori=\App\Models\Category::find($item->category_id);
                                ?>
                                <?php if($Categori): ?>
                                    <?php echo e($Categori->name); ?>

                                <?php else: ?>
                                    Néant
                                <?php endif; ?>

                            </option>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </select>
                    <?php if($errors->has('name')): ?>
                        <span class="invalid-feedback" role="alert">
                            <strong><?php echo e($errors->first('name')); ?></strong>
                        </span>
                    <?php endif; ?>
                </div>
                &nbsp; &nbsp;
                <div style="display: inline-block; vertical-align: top">
                    <label class="form-control-label" for="input-name"><?php echo e(__('Quantité')); ?></label>
                    <input type="number" class="form-control form-control-alternative" name="quantity[]" value="1"/>
                </div>

            </div>
        </template>

        <?php echo $__env->make('layouts.footers.auth', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
    </div>
<?php $__env->stopSection(); ?>

<?php $__env->startPush('js'); ?>
    <script>
        $('#btn-command').click(function(){
            $('#command-bloc').append($('#command').html())
        })
    </script>
<?php $__env->stopPush(); ?>
<?php echo $__env->make('layouts.app', ['title' => __('User Management')], \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php /* C:\wamp64\www\stock\resources\views/sale/create.blade.php */ ?>